$.fn.timer = function(props) {

    var _startTime = -1000,
        _elapsedTime = -1000,
        _countingEnable = false;

    var view = {
        appendHtml: function(el) {
            var html = '<div id="cob-timer">' +
                       '<span id="cob-timer-hour">00</span><span class="cob-timer-splitter">:</span>' +
                       '<span id="cob-timer-minute">00</span><span class="cob-timer-splitter">:</span>' +
                       '<span id="cob-timer-second">00</span>' +
                       '</div>';

            $(el).append(html)
        },

        updateTime: function(elapsedTime) {
            $("div#cob-timer span#cob-timer-hour").text(sprintf("%2d", Math.floor(elapsedTime / 3600000))
                .replace(' ', '0'));

            $("div#cob-timer span#cob-timer-minute").text(sprintf("%2d", Math.floor((elapsedTime / 60000) % 60))
                .replace(' ', '0'));

            $("div#cob-timer span#cob-timer-second").text(sprintf("%2d", Math.floor((elapsedTime / 1000) % 60))
                .replace(' ', '0'));
        }
    };

    if (props.display) {
        view.appendHtml($(this));
    }

    var count = function() {
        if (_countingEnable) {
            window.setTimeout(function() {
                count()
            }, 1000);
        }
        _elapsedTime += 1000;

        view.updateTime(_elapsedTime);

        handleJobs();
    };

    var handleJobs = function() {
        props.jobs.map(function(job) {
            if (_elapsedTime % (job.frequency * 1000) == 0) {
                if (typeof job.action === 'function') {
                    job.action();
                }
            }
        });
    };

    return {
        start: function(initialTime) {
            if (initialTime) {
                _elapsedTime = initialTime;
            }
            _countingEnable = true;
            count();
        },
        updateTime: function(elapsedTime) {
            _elapsedTime = Math.floor(elapsedTime / 1000) * 1000;
            view.updateTime(elapsedTime);
        },
        isRunning: function() {
            return _countingEnable;
        },

        stop: function() {
            _countingEnable = false;
        },

        reset: function() {
            _elapsedTime = _startTime;
        }
    }
};